/**
 * @license ngx-weui(cipchk@qq.com) v9.0.0-rc.1
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/chart-g2', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui']['chart-g2'] = {}), global.ng.core, global.ng.common));
}(this, (function (exports, core, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: chart-g2.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChartG2Directive = /** @class */ (function () {
        function ChartG2Directive(el, zone) {
            this.el = el;
            this.zone = zone;
            this.initFlag = false;
        }
        Object.defineProperty(ChartG2Directive.prototype, "chart", {
            /**
             * chart实例对象
             */
            get: /**
             * chart实例对象
             * @return {?}
             */
            function () {
                return this._chart;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ChartG2Directive.prototype, "GM", {
            /**
             * GM对象
             */
            get: /**
             * GM对象
             * @return {?}
             */
            function () {
                return GM;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ChartG2Directive.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.initFlag = true;
            this.buildChart();
        };
        /**
         * @private
         * @return {?}
         */
        ChartG2Directive.prototype.buildChart = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var object = {
                el: this.el.nativeElement,
            };
            if (this.margin)
                object.margin = this.margin;
            this.zone.runOutsideAngular((/**
             * @return {?}
             */
            function () {
                _this._chart = new GM.Chart(object);
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        ChartG2Directive.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (this.initFlag && changes.margin && !changes.margin.firstChange) {
                this.buildChart();
            }
        };
        /**
         * @return {?}
         */
        ChartG2Directive.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this._chart) {
                this.zone.runOutsideAngular((/**
                 * @return {?}
                 */
                function () {
                    // fixed: TypeError: Cannot read property 'stop' of null
                    try {
                        _this._chart.destroy();
                    }
                    catch (e) {
                        console.warn(e);
                    }
                }));
            }
        };
        ChartG2Directive.decorators = [
            { type: core.Directive, args: [{ selector: 'canvas[weui-chart-g2]', exportAs: 'weuiChartG2' },] }
        ];
        /** @nocollapse */
        ChartG2Directive.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.NgZone }
        ]; };
        ChartG2Directive.propDecorators = {
            margin: [{ type: core.Input }]
        };
        return ChartG2Directive;
    }());
    if (false) {
        /** @type {?} */
        ChartG2Directive.prototype._chart;
        /**
         * 画布内部的边距，可以是数组 [top, right, bottom, left] 也可以是一个数字。
         * @type {?}
         */
        ChartG2Directive.prototype.margin;
        /**
         * @type {?}
         * @private
         */
        ChartG2Directive.prototype.initFlag;
        /**
         * @type {?}
         * @private
         */
        ChartG2Directive.prototype.el;
        /**
         * @type {?}
         * @private
         */
        ChartG2Directive.prototype.zone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: chart-g2.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChartG2Module = /** @class */ (function () {
        function ChartG2Module() {
        }
        ChartG2Module.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [ChartG2Directive],
                        exports: [ChartG2Directive],
                    },] }
        ];
        return ChartG2Module;
    }());

    exports.ChartG2Directive = ChartG2Directive;
    exports.ChartG2Module = ChartG2Module;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-chart-g2.umd.js.map
