import { ApplicationRef, ComponentFactoryResolver, ComponentRef, Injector } from '@angular/core';
export declare abstract class BaseService {
    private resolver;
    private applicationRef;
    private injector;
    private doc;
    constructor(resolver: ComponentFactoryResolver, applicationRef: ApplicationRef, injector: Injector, doc: any);
    protected list: Array<ComponentRef<any>>;
    /**
     * 销毁
     *
     * @param component 下标（从0开始或组件引用对象），或不指定时，销毁最新一个
     */
    destroy(component?: number | ComponentRef<any>): void;
    /**
     * 销毁所有
     */
    destroyAll(): void;
    /** 动态构建组件 */
    protected build<T>(component: new (...args: any[]) => T): ComponentRef<T>;
}
