import { __assign, __extends } from 'tslib';
import { DOCUMENT, CommonModule } from '@angular/common';
import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, ChangeDetectorRef, Input, Output, ComponentFactoryResolver, ApplicationRef, Injector, Inject, ɵɵinject, INJECTOR, NgModule } from '@angular/core';
import { isAndroid, BaseService } from 'ngx-weui/core';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { Observable, Subscription } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * Generated from: actionsheet.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ActionSheetConfig = /** @class */ (function () {
    function ActionSheetConfig() {
        /**
         * 样式，默认：`ios`
         */
        this.skin = 'ios';
        /**
         * 取消文本，默认：`取消`
         */
        this.cancel = '取消';
        /**
         * 允许点击背景关闭，默认：`true`
         */
        this.backdrop = true;
    }
    ActionSheetConfig.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ ActionSheetConfig.ɵprov = ɵɵdefineInjectable({ factory: function ActionSheetConfig_Factory() { return new ActionSheetConfig(); }, token: ActionSheetConfig, providedIn: "root" });
    return ActionSheetConfig;
}());
if (false) {
    /**
     * 样式，默认：`ios`
     * @type {?}
     */
    ActionSheetConfig.prototype.skin;
    /**
     * 标题
     * @type {?}
     */
    ActionSheetConfig.prototype.title;
    /**
     * 取消文本，默认：`取消`
     * @type {?}
     */
    ActionSheetConfig.prototype.cancel;
    /**
     * 允许点击背景关闭，默认：`true`
     * @type {?}
     */
    ActionSheetConfig.prototype.backdrop;
}

/**
 * @fileoverview added by tsickle
 * Generated from: actionsheet.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ActionSheetComponent = /** @class */ (function () {
    function ActionSheetComponent(DEF, cdr) {
        this.DEF = DEF;
        this.cdr = cdr;
        this.destroied = false;
        this._shown = false;
        /**
         * 动画状态码
         */
        this._shownAnt = false;
        /**
         * 菜单内容
         */
        this.menus = [];
        /**
         * 关闭回调
         */
        this.close = new EventEmitter();
    }
    Object.defineProperty(ActionSheetComponent.prototype, "_visibility", {
        get: /**
         * @return {?}
         */
        function () {
            return this._shownAnt ? 'show' : 'hide';
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @private
     * @return {?}
     */
    ActionSheetComponent.prototype.detectChanges = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.destroied)
            return;
        this.cdr.detectChanges();
    };
    /**
     * 显示，组件载入页面后并不会显示，显示调用 `show()` 并订阅结果。
     */
    /**
     * 显示，组件载入页面后并不会显示，显示调用 `show()` 并订阅结果。
     * @return {?}
     */
    ActionSheetComponent.prototype.show = /**
     * 显示，组件载入页面后并不会显示，显示调用 `show()` 并订阅结果。
     * @return {?}
     */
    function () {
        var _this = this;
        this.config = __assign(__assign({ backdrop: true, skin: 'auto' }, this.DEF), this.config);
        if (this.config.skin === 'auto') {
            this.config.skin = isAndroid() ? 'android' : 'ios';
        }
        this._shown = true;
        setTimeout((/**
         * @return {?}
         */
        function () {
            _this._shownAnt = true;
            _this.detectChanges();
        }), 10);
        return new Observable((/**
         * @param {?} observer
         * @return {?}
         */
        function (observer) {
            _this.observer = observer;
        }));
    };
    /**
     * 隐藏
     *
     * @param is_backdrop 是否从背景上点击
     */
    /**
     * 隐藏
     *
     * @param {?=} is_backdrop 是否从背景上点击
     * @return {?}
     */
    ActionSheetComponent.prototype.hide = /**
     * 隐藏
     *
     * @param {?=} is_backdrop 是否从背景上点击
     * @return {?}
     */
    function (is_backdrop) {
        var _this = this;
        if (is_backdrop === true && this.config.backdrop === false) {
            return;
        }
        this._shownAnt = false;
        this.detectChanges();
        setTimeout((/**
         * @return {?}
         */
        function () {
            _this._shown = false;
            _this.close.emit();
        }), this.config.skin === 'android' ? 200 : 300);
    };
    /**
     * 选择动作
     */
    /**
     * 选择动作
     * @param {?} menu
     * @return {?}
     */
    ActionSheetComponent.prototype._onSelect = /**
     * 选择动作
     * @param {?} menu
     * @return {?}
     */
    function (menu) {
        this.observer.next(menu);
        this.observer.complete();
        this.hide();
    };
    /**
     * @return {?}
     */
    ActionSheetComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroied = true;
        if (this.observer && this.observer instanceof Subscription) {
            ((/** @type {?} */ (this.observer))).unsubscribe();
        }
    };
    ActionSheetComponent.decorators = [
        { type: Component, args: [{
                    selector: 'weui-actionsheet',
                    exportAs: 'weuiActionsheet',
                    template: "<div class=\"weui-mask\" [@visibility]=\"_visibility\" (click)=\"hide(true)\"></div>\n<div class=\"weui-actionsheet\" [ngClass]=\"{ 'weui-actionsheet_toggle': _shownAnt && config.skin === 'ios' }\">\n  <div class=\"weui-actionsheet__title\" *ngIf=\"config.skin === 'ios' && config.title\">\n    <p class=\"weui-actionsheet__title-text\">{{ config.title }}</p>\n  </div>\n  <div class=\"weui-actionsheet__menu\">\n    <div class=\"weui-actionsheet__cell\" *ngFor=\"let item of menus\" (click)=\"_onSelect(item)\" [class.weui-actionsheet__cell_warn]=\"item.type === 'warn'\">\n      {{ item.text }}\n    </div>\n  </div>\n  <div class=\"weui-actionsheet__action\" style=\"color: var(--weui-FG-0);\" *ngIf=\"config.skin === 'ios' && config.cancel\">\n    <div class=\"weui-actionsheet__cell\" (click)=\"hide()\">{{ config.cancel }}</div>\n  </div>\n</div>\n",
                    animations: [
                        trigger('visibility', [
                            state('show', style({ opacity: 1 })),
                            state('hide', style({ opacity: 0 })),
                            transition('hide <=> show', [animate(200)]),
                        ]),
                    ],
                    host: {
                        '[hidden]': '!_shown',
                        '[class.weui-skin_android]': 'config.skin === "android"',
                    },
                    preserveWhitespaces: false,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    ActionSheetComponent.ctorParameters = function () { return [
        { type: ActionSheetConfig },
        { type: ChangeDetectorRef }
    ]; };
    ActionSheetComponent.propDecorators = {
        config: [{ type: Input }],
        menus: [{ type: Input }],
        close: [{ type: Output }]
    };
    return ActionSheetComponent;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ActionSheetComponent.prototype.observer;
    /**
     * @type {?}
     * @private
     */
    ActionSheetComponent.prototype.destroied;
    /** @type {?} */
    ActionSheetComponent.prototype._shown;
    /**
     * 动画状态码
     * @type {?}
     */
    ActionSheetComponent.prototype._shownAnt;
    /**
     * 配置项
     * @type {?}
     */
    ActionSheetComponent.prototype.config;
    /**
     * 菜单内容
     * @type {?}
     */
    ActionSheetComponent.prototype.menus;
    /**
     * 关闭回调
     * @type {?}
     */
    ActionSheetComponent.prototype.close;
    /**
     * @type {?}
     * @private
     */
    ActionSheetComponent.prototype.DEF;
    /**
     * @type {?}
     * @private
     */
    ActionSheetComponent.prototype.cdr;
}

/**
 * @fileoverview added by tsickle
 * Generated from: actionsheet.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ActionSheetService = /** @class */ (function (_super) {
    __extends(ActionSheetService, _super);
    function ActionSheetService(resolver, applicationRef, injector, doc) {
        return _super.call(this, resolver, applicationRef, injector, doc) || this;
    }
    /**
     * 创建一个弹出式菜单并显示
     *
     * @param menus 菜单内容
     * @param config 配置性（可选）
     * @returns 可订阅来获取结果
     */
    /**
     * 创建一个弹出式菜单并显示
     *
     * @param {?} menus 菜单内容
     * @param {?=} config 配置性（可选）
     * @return {?} 可订阅来获取结果
     */
    ActionSheetService.prototype.show = /**
     * 创建一个弹出式菜单并显示
     *
     * @param {?} menus 菜单内容
     * @param {?=} config 配置性（可选）
     * @return {?} 可订阅来获取结果
     */
    function (menus, config) {
        var _this = this;
        if (config === void 0) { config = {}; }
        /** @type {?} */
        var componentRef = this.build(ActionSheetComponent);
        componentRef.instance.menus = menus;
        componentRef.instance.config = config;
        componentRef.instance.close.subscribe((/**
         * @return {?}
         */
        function () {
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this.destroy(componentRef);
            }), 100);
        }));
        return componentRef.instance.show();
    };
    ActionSheetService.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */
    ActionSheetService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ApplicationRef },
        { type: Injector },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ ActionSheetService.ɵprov = ɵɵdefineInjectable({ factory: function ActionSheetService_Factory() { return new ActionSheetService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR), ɵɵinject(DOCUMENT)); }, token: ActionSheetService, providedIn: "root" });
    return ActionSheetService;
}(BaseService));

/**
 * @fileoverview added by tsickle
 * Generated from: actionsheet.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ActionSheetModule = /** @class */ (function () {
    function ActionSheetModule() {
    }
    ActionSheetModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [ActionSheetComponent],
                    exports: [ActionSheetComponent],
                    entryComponents: [ActionSheetComponent],
                },] }
    ];
    return ActionSheetModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: actionsheet.types.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ActionSheetMenuItem() { }
if (false) {
    /** @type {?} */
    ActionSheetMenuItem.prototype.text;
    /** @type {?|undefined} */
    ActionSheetMenuItem.prototype.value;
    /**
     * - `warn` 表示负向菜单
     * @type {?|undefined}
     */
    ActionSheetMenuItem.prototype.type;
    /* Skipping unhandled member: [key: string]: any;*/
}

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-actionsheet.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ActionSheetComponent, ActionSheetConfig, ActionSheetModule, ActionSheetService };
//# sourceMappingURL=ngx-weui-actionsheet.js.map
