import { Directive, ElementRef, NgZone, Input, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: chart-g2.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ChartG2Directive = /** @class */ (function () {
    function ChartG2Directive(el, zone) {
        this.el = el;
        this.zone = zone;
        this.initFlag = false;
    }
    Object.defineProperty(ChartG2Directive.prototype, "chart", {
        /**
         * chart实例对象
         */
        get: /**
         * chart实例对象
         * @return {?}
         */
        function () {
            return this._chart;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartG2Directive.prototype, "GM", {
        /**
         * GM对象
         */
        get: /**
         * GM对象
         * @return {?}
         */
        function () {
            return GM;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    ChartG2Directive.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.initFlag = true;
        this.buildChart();
    };
    /**
     * @private
     * @return {?}
     */
    ChartG2Directive.prototype.buildChart = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var object = {
            el: this.el.nativeElement,
        };
        if (this.margin)
            object.margin = this.margin;
        this.zone.runOutsideAngular((/**
         * @return {?}
         */
        function () {
            _this._chart = new GM.Chart(object);
        }));
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    ChartG2Directive.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (this.initFlag && changes.margin && !changes.margin.firstChange) {
            this.buildChart();
        }
    };
    /**
     * @return {?}
     */
    ChartG2Directive.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this._chart) {
            this.zone.runOutsideAngular((/**
             * @return {?}
             */
            function () {
                // fixed: TypeError: Cannot read property 'stop' of null
                try {
                    _this._chart.destroy();
                }
                catch (e) {
                    console.warn(e);
                }
            }));
        }
    };
    ChartG2Directive.decorators = [
        { type: Directive, args: [{ selector: 'canvas[weui-chart-g2]', exportAs: 'weuiChartG2' },] }
    ];
    /** @nocollapse */
    ChartG2Directive.ctorParameters = function () { return [
        { type: ElementRef },
        { type: NgZone }
    ]; };
    ChartG2Directive.propDecorators = {
        margin: [{ type: Input }]
    };
    return ChartG2Directive;
}());
if (false) {
    /** @type {?} */
    ChartG2Directive.prototype._chart;
    /**
     * 画布内部的边距，可以是数组 [top, right, bottom, left] 也可以是一个数字。
     * @type {?}
     */
    ChartG2Directive.prototype.margin;
    /**
     * @type {?}
     * @private
     */
    ChartG2Directive.prototype.initFlag;
    /**
     * @type {?}
     * @private
     */
    ChartG2Directive.prototype.el;
    /**
     * @type {?}
     * @private
     */
    ChartG2Directive.prototype.zone;
}

/**
 * @fileoverview added by tsickle
 * Generated from: chart-g2.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ChartG2Module = /** @class */ (function () {
    function ChartG2Module() {
    }
    ChartG2Module.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [ChartG2Directive],
                    exports: [ChartG2Directive],
                },] }
    ];
    return ChartG2Module;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-chart-g2.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ChartG2Directive, ChartG2Module };
//# sourceMappingURL=ngx-weui-chart-g2.js.map
