import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, Input, Output, forwardRef, ViewChild, ComponentFactoryResolver, ApplicationRef, Injector, Inject, ɵɵinject, INJECTOR, NgModule } from '@angular/core';
import { __decorate, __metadata, __assign, __extends } from 'tslib';
import { InputNumber, InputBoolean, BaseService } from 'ngx-weui/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { DatePipe, DOCUMENT, CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: options.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function PickerOptions() { }
if (false) {
    /**
     * 类型
     * default：无任何显示
     * form：会以表单的形式出现
     * @see https://cipchk.github.io/ngx-weui/#/example/picker
     * @type {?|undefined}
     */
    PickerOptions.prototype.type;
    /**
     * 提示分隔符信息，当type==='form'时有效
     * @type {?|undefined}
     */
    PickerOptions.prototype.separator;
    /**
     * 取消按钮文本，默认：`取消`
     * @type {?|undefined}
     */
    PickerOptions.prototype.cancel;
    /**
     * 确定按钮文本，默认：`确定`
     * @type {?|undefined}
     */
    PickerOptions.prototype.confirm;
    /**
     * 允许点击背景关闭，默认：`true`
     * @type {?|undefined}
     */
    PickerOptions.prototype.backdrop;
}

/**
 * @fileoverview added by tsickle
 * Generated from: data.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function PickerData() { }
if (false) {
    /**
     * 显示文本
     * @type {?}
     */
    PickerData.prototype.label;
    /**
     * 值
     * @type {?}
     */
    PickerData.prototype.value;
    /**
     * 是否禁用
     * @type {?|undefined}
     */
    PickerData.prototype.disabled;
    /* Skipping unhandled member: [key: string]: any;*/
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PickerConfig = /** @class */ (function () {
    function PickerConfig() {
        /**
         * 取消按钮文本，默认：`取消`
         */
        this.cancel = '取消';
        /**
         * 确定按钮文本，默认：`确定`
         */
        this.confirm = '确定';
        /**
         * 允许点击背景关闭，默认：`true`
         */
        this.backdrop = true;
    }
    PickerConfig.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ PickerConfig.ɵprov = ɵɵdefineInjectable({ factory: function PickerConfig_Factory() { return new PickerConfig(); }, token: PickerConfig, providedIn: "root" });
    return PickerConfig;
}());
if (false) {
    /**
     * 取消按钮文本，默认：`取消`
     * @type {?}
     */
    PickerConfig.prototype.cancel;
    /**
     * 确定按钮文本，默认：`确定`
     * @type {?}
     */
    PickerConfig.prototype.confirm;
    /**
     * 允许点击背景关闭，默认：`true`
     * @type {?}
     */
    PickerConfig.prototype.backdrop;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker-group.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var getWindowHeight = (/**
 * @return {?}
 */
function () {
    return window.innerHeight;
});
var ɵ0 = getWindowHeight;
/**
 * 多列选择器组
 */
var PickerGroupComponent = /** @class */ (function () {
    function PickerGroupComponent() {
        /**
         * 当前默认位置
         */
        this.defaultIndex = -1;
        /**
         * 变更回调
         */
        this.change = new EventEmitter();
        this.defaults = {
            offset: 2,
            // 列表初始化时的偏移量（列表初始化时，选项是聚焦在中间的，通过offset强制往上挪3项，以达到初始选项是为顶部的那项）
            rowHeight: 48,
            // 列表每一行的高度
            bodyHeight: 5 * 48,
            // picker的高度，用于辅助点击滚动的计算
            inertiaTime: 150,
            // 惯性滑动的保持时间，此值直接影响“灵敏度” (单位：ms)
            slideDuration: 300,
        };
        // 手滑动的速度 (用途：速度乘以惯性滑动的时间, 例如 300ms, 计算出应该滑动的距离)
        this._animating = false;
        this._distance = 0;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    PickerGroupComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (changes.defaultIndex) {
            if (this.defaultIndex < 0 || (this.items && this.defaultIndex >= this.items.length)) {
                this.defaultIndex = 0;
            }
            this._distance = (this.defaults.offset - this.defaultIndex) * this.defaults.rowHeight;
        }
    };
    /**
     * @param {?} e
     * @return {?}
     */
    PickerGroupComponent.prototype.onTouchStart = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (this.items.length <= 1)
            return;
        this.startY = e.changedTouches[0].pageY;
        this.startTime = +new Date();
    };
    /**
     * @param {?} e
     * @return {?}
     */
    PickerGroupComponent.prototype.onTouchMove = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (this.items.length <= 1)
            return;
        /** @type {?} */
        var endTime = +new Date();
        this.endY = e.changedTouches[0].pageY;
        // 计算滑动的速度: 距离 / 时间
        /** @type {?} */
        var _distance = this.endY - this.startY;
        this.speed = _distance / (endTime - this.startTime);
        // 重新设置开始时间、开始位置
        this.startTime = endTime;
        this.startY = this.endY;
        this._animating = false; // ms
        this._distance += _distance; // 内容移动的距离
        e.preventDefault();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    PickerGroupComponent.prototype.onTouchEnd = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (!this.startY)
            return;
        this.endY = event.changedTouches[0].pageY;
        /**
         * 思路:
         * 根据最后一次touchmove事件的速度(speed)，判断是否执行惯性滑动；
         * 如果speed大于1、小于5，则根据速度乘以惯性滑动的时间(如150ms)，计算出应该滑动的距离；
         * 如果speed大于5，则按照屏幕的高度(减去列表高度的一半)，作为该滑动的距离。
         * @type {?}
         */
        var _speed = Math.abs(this.speed);
        if (_speed >= 5) {
            /** @type {?} */
            var windowY = getWindowHeight() - this.defaults.bodyHeight / 2;
            this.stop(windowY - this.endY);
        }
        else if (_speed >= 1) {
            /** @type {?} */
            var diff = this.speed * this.defaults.inertiaTime;
            this.stop(diff);
        }
        else {
            this.stop(0);
        }
        this.startY = 0;
    };
    /**
     * @private
     * @param {?} diff
     * @return {?}
     */
    PickerGroupComponent.prototype.stop = /**
     * @private
     * @param {?} diff
     * @return {?}
     */
    function (diff) {
        /** @type {?} */
        var dist = this._distance + diff;
        /** @type {?} */
        var defaults = this.defaults;
        // 移动到最接近的那一行
        dist = Math.round(dist / defaults.rowHeight) * defaults.rowHeight;
        /** @type {?} */
        var max = this._getMax(defaults.offset, defaults.rowHeight);
        /** @type {?} */
        var min = this._getMin(defaults.offset, defaults.rowHeight, this.items.length);
        // 不要超过最大值或者最小值
        dist = Math.max(Math.min(dist, max), min);
        // 如果是 disabled 的就跳过
        /** @type {?} */
        var index = defaults.offset - dist / defaults.rowHeight;
        while (!!this.items[index] && this.items[index].disabled) {
            diff > 0 ? ++index : --index;
        }
        dist = (defaults.offset - index) * defaults.rowHeight;
        this._animating = true;
        this._distance = dist; // px
        // 触发选择事件
        this.onChange(this.items[index], index);
    };
    /**
     * @private
     * @param {?} item
     * @param {?=} index
     * @return {?}
     */
    PickerGroupComponent.prototype.onChange = /**
     * @private
     * @param {?} item
     * @param {?=} index
     * @return {?}
     */
    function (item, index) {
        if (index === void 0) { index = 0; }
        this.change.emit({ item: item, index: index });
    };
    /**
     * @private
     * @param {?} offset
     * @param {?} rowHeight
     * @return {?}
     */
    PickerGroupComponent.prototype._getMax = /**
     * @private
     * @param {?} offset
     * @param {?} rowHeight
     * @return {?}
     */
    function (offset, rowHeight) {
        return offset * rowHeight;
    };
    /**
     * @private
     * @param {?} offset
     * @param {?} rowHeight
     * @param {?} length
     * @return {?}
     */
    PickerGroupComponent.prototype._getMin = /**
     * @private
     * @param {?} offset
     * @param {?} rowHeight
     * @param {?} length
     * @return {?}
     */
    function (offset, rowHeight, length) {
        return -(rowHeight * (length - offset - 1));
    };
    PickerGroupComponent.decorators = [
        { type: Component, args: [{
                    selector: 'weui-picker-group',
                    exportAs: 'weuiPickerGroup',
                    template: "<ng-content></ng-content>\n<div class=\"weui-picker__mask\"></div>\n<div class=\"weui-picker__indicator\"></div>\n<div\n  class=\"weui-picker__content\"\n  [ngStyle]=\"{\n    transform: 'translate3d(0,' + _distance + 'px, 0px)',\n    transition: _animating ? 'all 0.3s ease 0s' : 'none'\n  }\"\n>\n  <div class=\"weui-picker__item\" *ngFor=\"let item of items\" [ngClass]=\"{ 'weui-picker__item_disabled': item.disabled }\">\n    {{ item.label || item.value }}\n  </div>\n</div>\n",
                    host: {
                        '(touchstart)': 'onTouchStart($event)',
                        '(touchmove)': 'onTouchMove($event)',
                        '(touchend)': 'onTouchEnd($event)',
                        '[class.weui-picker__group]': 'true',
                    },
                    preserveWhitespaces: false,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    PickerGroupComponent.propDecorators = {
        items: [{ type: Input }],
        defaultIndex: [{ type: Input }],
        groupIndex: [{ type: Input }],
        change: [{ type: Output }]
    };
    __decorate([
        InputNumber(),
        __metadata("design:type", Number)
    ], PickerGroupComponent.prototype, "defaultIndex", void 0);
    __decorate([
        InputNumber(),
        __metadata("design:type", Number)
    ], PickerGroupComponent.prototype, "groupIndex", void 0);
    return PickerGroupComponent;
}());
if (false) {
    /**
     * 数据列表
     * @type {?}
     */
    PickerGroupComponent.prototype.items;
    /**
     * 当前默认位置
     * @type {?}
     */
    PickerGroupComponent.prototype.defaultIndex;
    /**
     * 多列中的位置
     * @type {?}
     */
    PickerGroupComponent.prototype.groupIndex;
    /**
     * 变更回调
     * @type {?}
     */
    PickerGroupComponent.prototype.change;
    /**
     * @type {?}
     * @private
     */
    PickerGroupComponent.prototype.defaults;
    /**
     * @type {?}
     * @private
     */
    PickerGroupComponent.prototype.startTime;
    /**
     * @type {?}
     * @private
     */
    PickerGroupComponent.prototype.startY;
    /**
     * @type {?}
     * @private
     */
    PickerGroupComponent.prototype.endY;
    /**
     * @type {?}
     * @private
     */
    PickerGroupComponent.prototype.speed;
    /** @type {?} */
    PickerGroupComponent.prototype._animating;
    /** @type {?} */
    PickerGroupComponent.prototype._distance;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PickerComponent = /** @class */ (function () {
    function PickerComponent(DEF) {
        this.DEF = DEF;
        this.onChange = Function.prototype;
        this.onTouched = Function.prototype;
        this._showP = false;
        this._shown = false;
        this._text = '';
        this.disabled = false;
        /**
         * 确认后回调当前选择数据（包括已选面板所有数据）
         *
         * `{ value: '10000', items: [ {}, {}, {} ] }`
         */
        this.change = new EventEmitter();
        /**
         * 列变更时回调
         */
        this.groupChange = new EventEmitter();
        /**
         * 取消后回调
         */
        this.cancel = new EventEmitter();
        /**
         * 显示时回调
         */
        this.show = new EventEmitter();
        /**
         * 隐藏后回调
         */
        this.hide = new EventEmitter();
    }
    Object.defineProperty(PickerComponent.prototype, "defaultSelect", {
        /**
         * 当前默认位置，数组的长度必须等同于 groups 长度
         */
        set: /**
         * 当前默认位置，数组的长度必须等同于 groups 长度
         * @param {?} d
         * @return {?}
         */
        function (d) {
            if (d)
                this._selected = d;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PickerComponent.prototype, "groups", {
        /**
         * 多列数据，以数组的长度来决定几列数据
         * 支持string[]单列数组，单纯只是为了方便
         */
        set: /**
         * 多列数据，以数组的长度来决定几列数据
         * 支持string[]单列数组，单纯只是为了方便
         * @param {?} d
         * @return {?}
         */
        function (d) {
            if (!d)
                throw new Error('无效数据源');
            if (d.length > 0) {
                if (typeof d[0] === 'string') {
                    d = [
                        ((/** @type {?} */ (d))).map((/**
                         * @param {?} v
                         * @return {?}
                         */
                        function (v) {
                            return { label: v, value: v };
                        })),
                    ];
                }
            }
            this._groups = (/** @type {?} */ (d));
            this._selected = this._selected ? this._selected : Array(d.length).fill(0);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    PickerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.options)
            this.parseOptions();
    };
    /**
     * @param {?} fh
     * @return {?}
     */
    PickerComponent.prototype._onHide = /**
     * @param {?} fh
     * @return {?}
     */
    function (fh) {
        var _this = this;
        if (!fh && !this.options.backdrop)
            return false;
        this._shown = false;
        setTimeout((/**
         * @return {?}
         */
        function () {
            _this._showP = false;
            _this.hide.emit();
        }), 300);
        return this;
    };
    /**
     * @return {?}
     */
    PickerComponent.prototype._onShow = /**
     * @return {?}
     */
    function () {
        if (this.disabled)
            return false;
        this._showP = true;
        this._shown = true;
        this.show.emit();
        return this;
    };
    /**
     * @private
     * @return {?}
     */
    PickerComponent.prototype.parseOptions = /**
     * @private
     * @return {?}
     */
    function () {
        this.options = (/** @type {?} */ (__assign(__assign({ type: 'form', cancel: '取消', confirm: '确定', backdrop: true, gruopCount: null, separator: ' ' }, this.DEF), this.options)));
    };
    /**
     * @private
     * @return {?}
     */
    PickerComponent.prototype.getSelecteItem = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var res = [];
        this._groups.forEach((/**
         * @param {?} items
         * @param {?} idx
         * @return {?}
         */
        function (items, idx) {
            /** @type {?} */
            var item = items[_this._selected[idx]];
            if (item)
                res.push(item);
        }));
        return res;
    };
    /**
     * @template THIS
     * @this {THIS}
     * @param {?=} res
     * @return {THIS}
     */
    PickerComponent.prototype._setText = /**
     * @template THIS
     * @this {THIS}
     * @param {?=} res
     * @return {THIS}
     */
    function (res) {
        if (res === void 0) { res = null; }
        if (res == null)
            res = (/** @type {?} */ (this)).getSelecteItem();
        if (res.length > 0)
            (/** @type {?} */ (this))._text = res.map((/**
             * @param {?} i
             * @return {?}
             */
            function (i) { return i.label || i.value; })).join((/** @type {?} */ (this)).options.separator);
        return (/** @type {?} */ (this));
    };
    // 根据_value解析成相应值位置
    // 根据_value解析成相应值位置
    /**
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    PickerComponent.prototype._setDefault = 
    // 根据_value解析成相应值位置
    /**
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    function () {
        var _this = this;
        (/** @type {?} */ (this))._selected = [];
        (/** @type {?} */ (this))._groups.forEach((/**
         * @param {?} items
         * @return {?}
         */
        function (items) {
            /** @type {?} */
            var idx = items.findIndex((/**
             * @param {?} i
             * @return {?}
             */
            function (i) { return i.value === (/** @type {?} */ (_this))._value; }));
            if (idx <= -1)
                idx = 0;
            (/** @type {?} */ (_this))._selected.push(idx);
        }));
        return (/** @type {?} */ (this));
    };
    /**
     * @param {?} data
     * @param {?} groupIndex
     * @return {?}
     */
    PickerComponent.prototype._onGroupChange = /**
     * @param {?} data
     * @param {?} groupIndex
     * @return {?}
     */
    function (data, groupIndex) {
        this._selected[groupIndex] = data.index;
        this.groupChange.emit({ item: data.item, index: data.index, groupIndex: groupIndex });
    };
    /**
     * @return {?}
     */
    PickerComponent.prototype._onCancel = /**
     * @return {?}
     */
    function () {
        this.cancel.emit();
        this._onHide(true);
        return false;
    };
    /**
     * @return {?}
     */
    PickerComponent.prototype._onConfirm = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var res = this.getSelecteItem();
        this._setText(res);
        /** @type {?} */
        var lastItem = res[res.length - 1] || {};
        /** @type {?} */
        var val = lastItem.value || lastItem.label;
        this.onChange(val);
        this.onTouched();
        this.change.emit({ value: val, items: res });
        this._onHide(true);
        return false;
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    PickerComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (changes.options) {
            this.parseOptions();
        }
    };
    /**
     * @param {?} value
     * @return {?}
     */
    PickerComponent.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        if (!value)
            this._text = '';
        if (value && value !== this._value) {
            this._value = value;
            // todo：当ngModel传递一个未列表中的值的情况 & 多列时数据对应问题
            this._setDefault()._setText();
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    PickerComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    PickerComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onTouched = fn;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    PickerComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.disabled = isDisabled;
    };
    /**
     * @param {?} ev
     * @return {?}
     */
    PickerComponent.prototype._onFocus = /**
     * @param {?} ev
     * @return {?}
     */
    function (ev) {
        ((/** @type {?} */ ((/** @type {?} */ (ev.target))))).blur();
    };
    PickerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'weui-picker',
                    exportAs: 'weuiPicker',
                    template: "<input\n  type=\"text\"\n  class=\"weui-input\"\n  value=\"{{ _text }}\"\n  placeholder=\"{{ placeholder }}\"\n  readonly=\"readonly\"\n  (focus)=\"_onFocus($event)\"\n  (click)=\"_onShow()\"\n  [disabled]=\"disabled\"\n  *ngIf=\"options.type === 'form'\"\n/>\n<div [hidden]=\"!_showP\">\n  <div class=\"weui-mask\" (click)=\"_onHide(false)\" [ngClass]=\"{ 'weui-animate-fade-in': _shown, 'weui-animate-fade-out': !_shown }\"></div>\n  <div class=\"weui-half-screen-dialog weui-picker\" [ngClass]=\"{ 'weui-animate-slide-up': _shown, 'weui-animate-slide-down': !_shown }\">\n    <div class=\"weui-half-screen-dialog__hd\">\n      <div class=\"weui-half-screen-dialog__hd__side\">\n        <button (click)=\"_onCancel()\" class=\"weui-icon-btn weui-icon-btn_close weui-picker__btn\">{{ options.cancel }}</button>\n      </div>\n      <div *ngIf=\"title\" class=\"weui-half-screen-dialog__hd__main\">\n        <strong class=\"weui-half-screen-dialog__title\">{{ title }}</strong>\n      </div>\n    </div>\n    <div class=\"weui-half-screen-dialog__bd\">\n      <div class=\"weui-picker__bd\">\n        <weui-picker-group\n          tappable\n          *ngFor=\"let items of _groups; let i = index\"\n          [items]=\"items\"\n          [defaultIndex]=\"_selected[i]\"\n          [groupIndex]=\"i\"\n          (change)=\"_onGroupChange($event, i)\"\n        ></weui-picker-group>\n      </div>\n    </div>\n    <div class=\"weui-half-screen-dialog__ft\">\n      <a class=\"weui-btn weui-btn_primary weui-picker__btn\" (click)=\"_onConfirm()\">{{ options.confirm }}</a>\n    </div>\n  </div>\n</div>\n",
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return PickerComponent; })),
                            multi: true,
                        },
                    ],
                    preserveWhitespaces: false,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    PickerComponent.ctorParameters = function () { return [
        { type: PickerConfig }
    ]; };
    PickerComponent.propDecorators = {
        options: [{ type: Input }],
        defaultSelect: [{ type: Input }],
        groups: [{ type: Input }],
        placeholder: [{ type: Input }],
        title: [{ type: Input }],
        disabled: [{ type: Input }],
        change: [{ type: Output }],
        groupChange: [{ type: Output }],
        cancel: [{ type: Output }],
        show: [{ type: Output }],
        hide: [{ type: Output }]
    };
    __decorate([
        InputBoolean(),
        __metadata("design:type", Boolean)
    ], PickerComponent.prototype, "disabled", void 0);
    return PickerComponent;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    PickerComponent.prototype.onChange;
    /**
     * @type {?}
     * @private
     */
    PickerComponent.prototype.onTouched;
    /** @type {?} */
    PickerComponent.prototype._showP;
    /** @type {?} */
    PickerComponent.prototype._shown;
    /**
     * 配置项
     * @type {?}
     */
    PickerComponent.prototype.options;
    /** @type {?} */
    PickerComponent.prototype._value;
    /** @type {?} */
    PickerComponent.prototype._selected;
    /** @type {?} */
    PickerComponent.prototype._groups;
    /** @type {?} */
    PickerComponent.prototype._text;
    /**
     * 当 `options.type==='form'` 时，占位符文本
     * @type {?}
     */
    PickerComponent.prototype.placeholder;
    /** @type {?} */
    PickerComponent.prototype.title;
    /** @type {?} */
    PickerComponent.prototype.disabled;
    /**
     * 确认后回调当前选择数据（包括已选面板所有数据）
     *
     * `{ value: '10000', items: [ {}, {}, {} ] }`
     * @type {?}
     */
    PickerComponent.prototype.change;
    /**
     * 列变更时回调
     * @type {?}
     */
    PickerComponent.prototype.groupChange;
    /**
     * 取消后回调
     * @type {?}
     */
    PickerComponent.prototype.cancel;
    /**
     * 显示时回调
     * @type {?}
     */
    PickerComponent.prototype.show;
    /**
     * 隐藏后回调
     * @type {?}
     */
    PickerComponent.prototype.hide;
    /**
     * @type {?}
     * @private
     */
    PickerComponent.prototype.DEF;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker-city.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * 城市选择器（并不包含城市数据，可以参考示例中的数据格式）
 */
var CityPickerComponent = /** @class */ (function () {
    function CityPickerComponent() {
        this.onChange = Function.prototype;
        this.onTouched = Function.prototype;
        this._groups = [];
        this._selected = [];
        this.dataMap = {
            label: 'name',
            value: 'code',
            items: 'sub',
        };
        /**
         * 确认后回调当前选择数据（包括已选面板所有数据）
         *
         * `{ value: '10000', items: [ {}, {}, {} ] }`
         */
        this.change = new EventEmitter();
        /**
         * 列变更时回调
         */
        this.groupChange = new EventEmitter();
        /**
         * 取消后回调
         */
        this.cancel = new EventEmitter();
        /**
         * 显示时回调
         */
        this.show = new EventEmitter();
        /**
         * 隐藏后回调
         */
        this.hide = new EventEmitter();
    }
    Object.defineProperty(CityPickerComponent.prototype, "data", {
        /** 城市数据，可以参考示例中的数据格式 */
        set: /**
         * 城市数据，可以参考示例中的数据格式
         * @param {?} d
         * @return {?}
         */
        function (d) {
            this._tmpData = d;
            this.parseData(this._tmpData, this.dataMap.items, this._selected);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    CityPickerComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this._tmpData = null;
        this._groups = null;
    };
    /**
     * @private
     * @param {?} data
     * @param {?} subKey
     * @param {?=} selected
     * @param {?=} group
     * @param {?=} newselected
     * @return {?}
     */
    CityPickerComponent.prototype.parseData = /**
     * @private
     * @param {?} data
     * @param {?} subKey
     * @param {?=} selected
     * @param {?=} group
     * @param {?=} newselected
     * @return {?}
     */
    function (data, subKey, selected, group, newselected) {
        var _this = this;
        if (selected === void 0) { selected = []; }
        if (group === void 0) { group = []; }
        if (newselected === void 0) { newselected = []; }
        /** @type {?} */
        var _selected = 0;
        if (Array.isArray(selected) && selected.length > 0) {
            /** @type {?} */
            var _selectedClone = selected.slice(0);
            _selected = _selectedClone.shift();
            selected = _selectedClone;
        }
        if (typeof data[_selected] === 'undefined') {
            _selected = 0;
        }
        newselected.push(_selected);
        /** @type {?} */
        var item = data[_selected];
        /** @type {?} */
        var _group = JSON.parse(JSON.stringify(data));
        _group.forEach((/**
         * @param {?} g
         * @return {?}
         */
        function (g) {
            delete g[subKey];
            g.label = g[_this.dataMap.label];
            g.value = g[_this.dataMap.value];
        }));
        group.push(_group);
        if (typeof item[subKey] !== 'undefined' && Array.isArray(item[subKey])) {
            return this.parseData(item[subKey], subKey, selected, group, newselected);
        }
        else {
            this._groups = group;
            this._selected = newselected;
            return { groups: group, newselected: newselected };
        }
    };
    /**
     * 将值转换成位置
     */
    /**
     * 将值转换成位置
     * @private
     * @param {?} data
     * @param {?} subKey
     * @param {?=} dept
     * @param {?=} newSelected
     * @return {?}
     */
    CityPickerComponent.prototype.valueToSelect = /**
     * 将值转换成位置
     * @private
     * @param {?} data
     * @param {?} subKey
     * @param {?=} dept
     * @param {?=} newSelected
     * @return {?}
     */
    function (data, subKey, dept, newSelected) {
        var _this = this;
        if (dept === void 0) { dept = 1; }
        if (newSelected === void 0) { newSelected = []; }
        /** @type {?} */
        var code = (this._value.substr(0, dept * 2) + '0000').substr(0, 6);
        /** @type {?} */
        var _selected = data.findIndex((/**
         * @param {?} w
         * @return {?}
         */
        function (w) { return w[_this.dataMap.value] === code; }));
        if (_selected <= -1) {
            _selected = 0;
        }
        newSelected.push(_selected);
        /** @type {?} */
        var item = data[_selected];
        if (typeof item[subKey] !== 'undefined' && Array.isArray(item[subKey])) {
            return this.valueToSelect(item[subKey], subKey, ++dept, newSelected);
        }
        else {
            this._selected = newSelected;
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this._pickerInstance._setText();
            }), 100);
            return newSelected;
        }
    };
    /**
     * @param {?} data
     * @return {?}
     */
    CityPickerComponent.prototype._onCityChange = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.onChange(data.value);
        this.onTouched();
        this.change.emit(data);
    };
    /**
     * @param {?} res
     * @return {?}
     */
    CityPickerComponent.prototype._onCityGroupChange = /**
     * @param {?} res
     * @return {?}
     */
    function (res) {
        this._selected[res.groupIndex] = res.index;
        if (res.groupIndex !== 2)
            this.parseData(this._tmpData, this.dataMap.items, this._selected);
        this.groupChange.emit(res);
    };
    /**
     * @return {?}
     */
    CityPickerComponent.prototype._onCityCancelChange = /**
     * @return {?}
     */
    function () {
        this.cancel.emit();
    };
    /** 服务于Service，并无实际意义 */
    /**
     * 服务于Service，并无实际意义
     * @return {?}
     */
    CityPickerComponent.prototype._triggerShow = /**
     * 服务于Service，并无实际意义
     * @return {?}
     */
    function () {
        this._pickerInstance._onShow();
    };
    /**
     * @return {?}
     */
    CityPickerComponent.prototype._onShow = /**
     * @return {?}
     */
    function () {
        this.show.emit();
    };
    /**
     * @return {?}
     */
    CityPickerComponent.prototype._onHide = /**
     * @return {?}
     */
    function () {
        this.hide.emit();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    CityPickerComponent.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        if (!value) {
            this._pickerInstance._text = '';
            return;
        }
        this._value = value;
        if (this._value && this._value.length === 6) {
            this.valueToSelect(this._tmpData, this.dataMap.items, 1);
            this.parseData(this._tmpData, this.dataMap.items, this._selected);
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    CityPickerComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    CityPickerComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onTouched = fn;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    CityPickerComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.disabled = isDisabled;
    };
    CityPickerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'weui-city-picker',
                    exportAs: 'weuiCityPicker',
                    template: "\n    <weui-picker\n      [placeholder]=\"placeholder\"\n      [groups]=\"_groups!\"\n      [defaultSelect]=\"_selected\"\n      [disabled]=\"disabled\"\n      [title]=\"title\"\n      [options]=\"options\"\n      (show)=\"_onShow()\"\n      (hide)=\"_onHide()\"\n      (change)=\"_onCityChange($event)\"\n      (groupChange)=\"_onCityGroupChange($event)\"\n      (cancel)=\"_onCityCancelChange()\"\n    ></weui-picker>\n  ",
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return CityPickerComponent; })),
                            multi: true,
                        },
                    ],
                    preserveWhitespaces: false,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    CityPickerComponent.propDecorators = {
        data: [{ type: Input }],
        _pickerInstance: [{ type: ViewChild, args: [PickerComponent, { static: true },] }],
        dataMap: [{ type: Input }],
        options: [{ type: Input }],
        placeholder: [{ type: Input }],
        title: [{ type: Input }],
        disabled: [{ type: Input }],
        change: [{ type: Output }],
        groupChange: [{ type: Output }],
        cancel: [{ type: Output }],
        show: [{ type: Output }],
        hide: [{ type: Output }]
    };
    __decorate([
        InputBoolean(),
        __metadata("design:type", Boolean)
    ], CityPickerComponent.prototype, "disabled", void 0);
    return CityPickerComponent;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    CityPickerComponent.prototype._tmpData;
    /**
     * @type {?}
     * @private
     */
    CityPickerComponent.prototype.onChange;
    /**
     * @type {?}
     * @private
     */
    CityPickerComponent.prototype.onTouched;
    /** @type {?} */
    CityPickerComponent.prototype._value;
    /** @type {?} */
    CityPickerComponent.prototype._groups;
    /** @type {?} */
    CityPickerComponent.prototype._selected;
    /** @type {?} */
    CityPickerComponent.prototype._pickerInstance;
    /** @type {?} */
    CityPickerComponent.prototype.dataMap;
    /**
     * 配置项
     * @type {?}
     */
    CityPickerComponent.prototype.options;
    /**
     * 当options.type=='form'时，占位符文本
     * @type {?}
     */
    CityPickerComponent.prototype.placeholder;
    /** @type {?} */
    CityPickerComponent.prototype.title;
    /** @type {?} */
    CityPickerComponent.prototype.disabled;
    /**
     * 确认后回调当前选择数据（包括已选面板所有数据）
     *
     * `{ value: '10000', items: [ {}, {}, {} ] }`
     * @type {?}
     */
    CityPickerComponent.prototype.change;
    /**
     * 列变更时回调
     * @type {?}
     */
    CityPickerComponent.prototype.groupChange;
    /**
     * 取消后回调
     * @type {?}
     */
    CityPickerComponent.prototype.cancel;
    /**
     * 显示时回调
     * @type {?}
     */
    CityPickerComponent.prototype.show;
    /**
     * 隐藏后回调
     * @type {?}
     */
    CityPickerComponent.prototype.hide;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker-date.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var FORMAT = {
    format: null,
    yu: '年',
    Mu: '月',
    du: '日',
    hu: '时',
    mu: '分',
};
/**
 * 日期时间选择器
 */
var DatePickerComponent = /** @class */ (function () {
    function DatePickerComponent(datePipe) {
        this.datePipe = datePipe;
        this.initFlag = false;
        this.onChange = Function.prototype;
        this.onTouched = Function.prototype;
        this._groups = [];
        this._selected = [];
        /**
         * 类型
         * + `date-ym` 年月
         * + `date` 日期
         * + `datetime` 日期&时间（不包括秒）
         * + `time` 时间（不包括秒）
         */
        this.type = 'date';
        this._format = __assign({}, FORMAT);
        /**
         * 确认后回调
         */
        this.change = new EventEmitter();
        /**
         * 列变更时回调
         */
        this.groupChange = new EventEmitter();
        /**
         * 取消后回调
         */
        this.cancel = new EventEmitter();
        /**
         * 显示时回调
         */
        this.show = new EventEmitter();
        /**
         * 隐藏后回调
         */
        this.hide = new EventEmitter();
    }
    Object.defineProperty(DatePickerComponent.prototype, "format", {
        /**
         * 日期格式化代码，实际是采用 DatePipe，所有代码内容和它一样
         */
        set: /**
         * 日期格式化代码，实际是采用 DatePipe，所有代码内容和它一样
         * @param {?} v
         * @return {?}
         */
        function (v) {
            if (typeof v === 'string') {
                this._format = __assign(__assign({}, FORMAT), { format: v });
            }
            else {
                this._format = __assign(__assign({}, FORMAT), v);
            }
        },
        enumerable: true,
        configurable: true
    });
    // todo: 太粗暴，需要优化代码
    // todo: 太粗暴，需要优化代码
    /**
     * @private
     * @return {?}
     */
    DatePickerComponent.prototype.genGroups = 
    // todo: 太粗暴，需要优化代码
    /**
     * @private
     * @return {?}
     */
    function () {
        if (!this._value)
            this._value = new Date();
        this._groups = [];
        this._selected = [];
        if (~this.type.indexOf('date'))
            this.genDateGroups();
        if (~this.type.indexOf('time'))
            this.genDateTimeGroups();
    };
    /**
     * @private
     * @return {?}
     */
    DatePickerComponent.prototype.genDateGroups = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var year = this._value.getFullYear();
        /** @type {?} */
        var month = this._value.getMonth() + 1;
        /** @type {?} */
        var day = this._value.getDate();
        // year
        /** @type {?} */
        var _selected = 0;
        /** @type {?} */
        var startYear = year - 10;
        /** @type {?} */
        var endYear = year + 10;
        if (this.min)
            startYear = this.min.getFullYear();
        if (this.max)
            endYear = this.max.getFullYear();
        this._groups.push(Array(endYear - startYear + 1)
            .fill(0)
            .map((/**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */
        function (_v, idx) {
            /** @type {?} */
            var val = startYear + idx;
            if (val === year)
                _selected = idx;
            return { label: val + _this._format.yu, value: val };
        })));
        this._selected.push(_selected);
        // month
        /** @type {?} */
        var cy = this._groups[0][_selected].value;
        /** @type {?} */
        var startMonth = 1;
        /** @type {?} */
        var endMonth = 12;
        if (cy === startYear)
            startMonth = this.min.getMonth() + 1;
        if (cy === endYear)
            endMonth = this.max.getMonth() + 1;
        _selected = 0;
        this._groups.push(Array(endMonth - startMonth + 1)
            .fill(0)
            .map((/**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */
        function (_v, idx) {
            /** @type {?} */
            var val = startMonth + idx;
            if (val === month)
                _selected = idx;
            return { label: val + _this._format.Mu, value: val };
        })));
        this._selected.push(_selected);
        // day
        if (this.type !== 'date-ym') {
            /** @type {?} */
            var cm = this._groups[1][_selected].value;
            /** @type {?} */
            var startDay_1 = 1;
            /** @type {?} */
            var endDay = new Date(year, month, 0).getDate();
            if (cy === startYear && cm === startMonth)
                startDay_1 = this.min.getDate();
            if (cy === endYear && cm === endMonth)
                endDay = this.max.getDate();
            _selected = 0;
            this._groups.push(Array(endDay - startDay_1 + 1)
                .fill(0)
                .map((/**
             * @param {?} _v
             * @param {?} idx
             * @return {?}
             */
            function (_v, idx) {
                /** @type {?} */
                var val = startDay_1 + idx;
                if (val === day)
                    _selected = idx;
                return { label: val + _this._format.du, value: val };
            })));
            this._selected.push(_selected);
        }
    };
    /**
     * @private
     * @return {?}
     */
    DatePickerComponent.prototype.genDateTimeGroups = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var hours = this._value.getHours();
        /** @type {?} */
        var minutes = this._value.getMinutes();
        // hours
        /** @type {?} */
        var _selected = 0;
        this._groups.push(Array(24)
            .fill(0)
            .map((/**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */
        function (_v, idx) {
            /** @type {?} */
            var val = idx;
            if (val === hours)
                _selected = idx;
            return { label: val + _this._format.hu, value: val };
        })));
        this._selected.push(_selected);
        // minutes
        _selected = 0;
        this._groups.push(Array(60)
            .fill(0)
            .map((/**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */
        function (_v, idx) {
            /** @type {?} */
            var val = idx;
            if (val === minutes)
                _selected = idx;
            return { label: val + _this._format.mu, value: val };
        })));
        this._selected.push(_selected);
    };
    // 根据selected
    // 根据selected
    /**
     * @private
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    DatePickerComponent.prototype.genValueBySelected = 
    // 根据selected
    /**
     * @private
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    function () {
        if ((/** @type {?} */ (this)).type === 'time') {
            /** @type {?} */
            var now = new Date();
            (/** @type {?} */ (this))._value = new Date(now.getFullYear(), now.getMonth() + 1, now.getDate(), (/** @type {?} */ (this))._groups[0][(/** @type {?} */ (this))._selected[0]].value, (/** @type {?} */ (this))._groups[1][(/** @type {?} */ (this))._selected[1]].value, 0);
            return (/** @type {?} */ (this));
        }
        /** @type {?} */
        var obj = {
            y: (/** @type {?} */ (this))._groups[0][(/** @type {?} */ (this))._selected[0]].value,
            M: (/** @type {?} */ (this))._groups[1][(/** @type {?} */ (this))._selected[1]].value - 1,
            d: (/** @type {?} */ (this)).type !== 'date-ym' ? (/** @type {?} */ (this))._groups[2][(/** @type {?} */ (this))._selected[2]].value : 1,
            h: 0,
            m: 0,
            s: 0,
        };
        if (~(/** @type {?} */ (this)).type.indexOf('time')) {
            obj.h = (/** @type {?} */ (this))._groups[3][(/** @type {?} */ (this))._selected[3]].value;
            obj.m = (/** @type {?} */ (this))._groups[4][(/** @type {?} */ (this))._selected[4]].value;
        }
        (/** @type {?} */ (this))._value = new Date(obj.y, obj.M, obj.d, obj.h, obj.m, obj.s);
        return (/** @type {?} */ (this));
    };
    /**
     * @return {?}
     */
    DatePickerComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this._groups.length = 0;
    };
    /**
     * @private
     * @param {?} date
     * @return {?}
     */
    DatePickerComponent.prototype.getFormatDate = /**
     * @private
     * @param {?} date
     * @return {?}
     */
    function (date) {
        /** @type {?} */
        var f = '';
        if (this._format && this._format.format)
            f = this._format.format;
        else {
            switch (this.type) {
                case 'date-ym':
                    f = 'yyyy-MM';
                    break;
                case 'date':
                    f = 'yyyy-MM-dd';
                    break;
                case 'datetime':
                    f = 'yyyy-MM-dd HH:mm:ss';
                    break;
                case 'time':
                    f = 'HH:mm';
                    break;
            }
        }
        return this.datePipe.transform(date, f);
    };
    /**
     * @param {?} data
     * @return {?}
     */
    DatePickerComponent.prototype._onCityChange = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.genValueBySelected();
        /** @type {?} */
        var retVal = new Date(this._value.getTime());
        this.onChange(retVal);
        this.onTouched();
        data.value = retVal;
        data.formatValue = this.getFormatDate(retVal);
        this._pickerInstance._text = data.formatValue;
        this.change.emit(data);
    };
    /**
     * @param {?} res
     * @return {?}
     */
    DatePickerComponent.prototype._onCityGroupChange = /**
     * @param {?} res
     * @return {?}
     */
    function (res) {
        this._selected[res.groupIndex] = res.index;
        if (res.groupIndex !== this._groups.length - 1) {
            this.genValueBySelected().genGroups();
        }
        this.groupChange.emit(res);
    };
    /**
     * @return {?}
     */
    DatePickerComponent.prototype._onCityCancelChange = /**
     * @return {?}
     */
    function () {
        this.cancel.emit();
    };
    /**
     * @return {?}
     */
    DatePickerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.initFlag = true;
        this.genGroups();
    };
    /**
     * @return {?}
     */
    DatePickerComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        if (this.initFlag)
            this.genGroups();
    };
    /** 服务于Service，并无实际意义 */
    /**
     * 服务于Service，并无实际意义
     * @return {?}
     */
    DatePickerComponent.prototype._triggerShow = /**
     * 服务于Service，并无实际意义
     * @return {?}
     */
    function () {
        this._pickerInstance._onShow();
    };
    /**
     * @return {?}
     */
    DatePickerComponent.prototype._onShow = /**
     * @return {?}
     */
    function () {
        this.show.emit();
    };
    /**
     * @return {?}
     */
    DatePickerComponent.prototype._onHide = /**
     * @return {?}
     */
    function () {
        this.hide.emit();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    DatePickerComponent.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        if (value)
            this.genGroups();
        this._value = value;
        this._pickerInstance._text = value instanceof Date ? (/** @type {?} */ (this.getFormatDate(value))) : '';
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    DatePickerComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    DatePickerComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onTouched = fn;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    DatePickerComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.disabled = isDisabled;
    };
    DatePickerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'weui-date-picker',
                    exportAs: 'weuiDatePicker',
                    template: "\n    <weui-picker\n      [placeholder]=\"placeholder\"\n      [groups]=\"_groups\"\n      [defaultSelect]=\"_selected\"\n      [disabled]=\"disabled\"\n      [title]=\"title\"\n      [options]=\"options\"\n      (show)=\"_onShow()\"\n      (hide)=\"_onHide()\"\n      (change)=\"_onCityChange($event)\"\n      (groupChange)=\"_onCityGroupChange($event)\"\n      (cancel)=\"_onCityCancelChange()\"\n    ></weui-picker>\n  ",
                    providers: [
                        DatePipe,
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return DatePickerComponent; })),
                            multi: true,
                        },
                    ],
                    preserveWhitespaces: false,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    DatePickerComponent.ctorParameters = function () { return [
        { type: DatePipe }
    ]; };
    DatePickerComponent.propDecorators = {
        _pickerInstance: [{ type: ViewChild, args: [PickerComponent, { static: true },] }],
        min: [{ type: Input }],
        max: [{ type: Input }],
        type: [{ type: Input }],
        format: [{ type: Input }],
        options: [{ type: Input }],
        placeholder: [{ type: Input }],
        title: [{ type: Input }],
        disabled: [{ type: Input }],
        change: [{ type: Output }],
        groupChange: [{ type: Output }],
        cancel: [{ type: Output }],
        show: [{ type: Output }],
        hide: [{ type: Output }]
    };
    __decorate([
        InputBoolean(),
        __metadata("design:type", Boolean)
    ], DatePickerComponent.prototype, "disabled", void 0);
    return DatePickerComponent;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    DatePickerComponent.prototype.initFlag;
    /**
     * @type {?}
     * @private
     */
    DatePickerComponent.prototype.onChange;
    /**
     * @type {?}
     * @private
     */
    DatePickerComponent.prototype.onTouched;
    /** @type {?} */
    DatePickerComponent.prototype._pickerInstance;
    /** @type {?} */
    DatePickerComponent.prototype._value;
    /** @type {?} */
    DatePickerComponent.prototype._groups;
    /** @type {?} */
    DatePickerComponent.prototype._selected;
    /**
     * 最小时间范围
     * - 当前只限定年月日，暂不包括时间范围
     * @type {?}
     */
    DatePickerComponent.prototype.min;
    /**
     * 最大时间范围
     * - 当前只限定年月日，暂不包括时间范围
     * @type {?}
     */
    DatePickerComponent.prototype.max;
    /**
     * 类型
     * + `date-ym` 年月
     * + `date` 日期
     * + `datetime` 日期&时间（不包括秒）
     * + `time` 时间（不包括秒）
     * @type {?}
     */
    DatePickerComponent.prototype.type;
    /**
     * @type {?}
     * @private
     */
    DatePickerComponent.prototype._format;
    /**
     * 配置项
     * @type {?}
     */
    DatePickerComponent.prototype.options;
    /**
     * 当options.type=='form'时，占位符文本
     * @type {?}
     */
    DatePickerComponent.prototype.placeholder;
    /** @type {?} */
    DatePickerComponent.prototype.title;
    /** @type {?} */
    DatePickerComponent.prototype.disabled;
    /**
     * 确认后回调
     * @type {?}
     */
    DatePickerComponent.prototype.change;
    /**
     * 列变更时回调
     * @type {?}
     */
    DatePickerComponent.prototype.groupChange;
    /**
     * 取消后回调
     * @type {?}
     */
    DatePickerComponent.prototype.cancel;
    /**
     * 显示时回调
     * @type {?}
     */
    DatePickerComponent.prototype.show;
    /**
     * 隐藏后回调
     * @type {?}
     */
    DatePickerComponent.prototype.hide;
    /**
     * @type {?}
     * @private
     */
    DatePickerComponent.prototype.datePipe;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * 多列选择器Service，可直接通过Class构造选择器
 */
var PickerService = /** @class */ (function (_super) {
    __extends(PickerService, _super);
    function PickerService(resolver, applicationRef, injector, doc) {
        return _super.call(this, resolver, applicationRef, injector, doc) || this;
    }
    /**
     * 构建一个多列选择器并显示
     *
     * @param data 数据源
     * @param value 默认值（限单列时会根据值自动解析，而对多列使用defaultSelect自行解析）
     * @param defaultSelect 当前默认位置，数组的长度必须等同于 groups 长度
     * @param options 配置项
     * @returns 务必订阅结果才会显示。
     */
    /**
     * 构建一个多列选择器并显示
     *
     * @param {?} data 数据源
     * @param {?=} value 默认值（限单列时会根据值自动解析，而对多列使用defaultSelect自行解析）
     * @param {?=} defaultSelect 当前默认位置，数组的长度必须等同于 groups 长度
     * @param {?=} options 配置项
     * @return {?} 务必订阅结果才会显示。
     */
    PickerService.prototype.show = /**
     * 构建一个多列选择器并显示
     *
     * @param {?} data 数据源
     * @param {?=} value 默认值（限单列时会根据值自动解析，而对多列使用defaultSelect自行解析）
     * @param {?=} defaultSelect 当前默认位置，数组的长度必须等同于 groups 长度
     * @param {?=} options 配置项
     * @return {?} 务必订阅结果才会显示。
     */
    function (data, value, defaultSelect, options) {
        var _this = this;
        /** @type {?} */
        var componentRef = this.build(PickerComponent);
        // 通过Service打开的强制设置为 `default` 以免出现 `input`
        options = __assign(__assign({}, options), { type: 'default' });
        componentRef.instance.options = options;
        if (defaultSelect)
            componentRef.instance.defaultSelect = defaultSelect;
        componentRef.instance.groups = data;
        if (value) {
            setTimeout((/**
             * @return {?}
             */
            function () {
                componentRef.instance.writeValue(value);
            }), 100);
        }
        componentRef.instance.hide.subscribe((/**
         * @return {?}
         */
        function () {
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this.destroy(componentRef);
            }), 100);
        }));
        componentRef.instance._onShow();
        return componentRef.instance.change;
    };
    /**
     * 构建一个城市选择器并显示
     *
     * @param data 城市数据，可以参考示例中的数据格式
     * @param [value] 默认值，即城市编号
     * @param options 配置项
     * @returns 务必订阅结果才会显示。
     */
    /**
     * 构建一个城市选择器并显示
     *
     * @param {?} data 城市数据，可以参考示例中的数据格式
     * @param {?=} value
     * @param {?=} dataMap
     * @param {?=} options 配置项
     * @return {?} 务必订阅结果才会显示。
     */
    PickerService.prototype.showCity = /**
     * 构建一个城市选择器并显示
     *
     * @param {?} data 城市数据，可以参考示例中的数据格式
     * @param {?=} value
     * @param {?=} dataMap
     * @param {?=} options 配置项
     * @return {?} 务必订阅结果才会显示。
     */
    function (data, value, dataMap, options) {
        var _this = this;
        /** @type {?} */
        var componentRef = this.build(CityPickerComponent);
        if (dataMap)
            componentRef.instance.dataMap = dataMap;
        // 通过Service打开的强制设置为 `default` 以免出现 `input`
        options = __assign(__assign({}, options), { type: 'default' });
        componentRef.instance.options = options;
        componentRef.instance.data = data;
        if (value) {
            setTimeout((/**
             * @return {?}
             */
            function () {
                componentRef.instance.writeValue(value);
            }), 100);
        }
        componentRef.instance.hide.subscribe((/**
         * @return {?}
         */
        function () {
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this.destroy(componentRef);
            }), 100);
        }));
        setTimeout((/**
         * @return {?}
         */
        function () {
            componentRef.instance._triggerShow();
        }), 200);
        return componentRef.instance.change;
    };
    /**
     * 构建一个日期时间选择器并显示
     *
     * @param [type] 类型，date-ym年月，date日期，datetime日期&时间（不包括秒），time时间（不包括秒）
     * @param [format] 日期格式化代码，实际是采用 DatePipe，所有代码内容和它一样
     * @param [value] 默认显示日期
     * @param [min] 最小时间范围
     * @param [max] 最大时间范围
     * @param [options] 配置项
     * @returns 务必订阅结果才会显示。
     */
    /**
     * 构建一个日期时间选择器并显示
     *
     * @param {?=} type
     * @param {?=} format
     * @param {?=} value
     * @param {?=} min
     * @param {?=} max
     * @param {?=} options
     * @return {?} 务必订阅结果才会显示。
     */
    PickerService.prototype.showDateTime = /**
     * 构建一个日期时间选择器并显示
     *
     * @param {?=} type
     * @param {?=} format
     * @param {?=} value
     * @param {?=} min
     * @param {?=} max
     * @param {?=} options
     * @return {?} 务必订阅结果才会显示。
     */
    function (type, format, value, min, max, options) {
        var _this = this;
        /** @type {?} */
        var componentRef = this.build(DatePickerComponent);
        // 通过Service打开的强制设置为 `default` 以免出现 `input`
        options = __assign(__assign({}, options), { type: 'default' });
        componentRef.instance.options = options;
        if (type)
            componentRef.instance.type = type;
        if (format)
            componentRef.instance.format = format;
        if (min)
            componentRef.instance.min = min;
        if (max)
            componentRef.instance.max = max;
        if (value) {
            setTimeout((/**
             * @return {?}
             */
            function () {
                componentRef.instance.writeValue(value);
            }), 100);
        }
        componentRef.instance.hide.subscribe((/**
         * @return {?}
         */
        function () {
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this.destroy(componentRef);
            }), 100);
        }));
        setTimeout((/**
         * @return {?}
         */
        function () {
            componentRef.instance.ngOnChanges();
            componentRef.instance._triggerShow();
        }), 200);
        return componentRef.instance.change;
    };
    PickerService.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */
    PickerService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ApplicationRef },
        { type: Injector },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ PickerService.ɵprov = ɵɵdefineInjectable({ factory: function PickerService_Factory() { return new PickerService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR), ɵɵinject(DOCUMENT)); }, token: PickerService, providedIn: "root" });
    return PickerService;
}(BaseService));

/**
 * @fileoverview added by tsickle
 * Generated from: picker.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var COMPONENTS = [PickerComponent, PickerGroupComponent, DatePickerComponent, CityPickerComponent];
var PickerModule = /** @class */ (function () {
    function PickerModule() {
    }
    PickerModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: COMPONENTS,
                    exports: COMPONENTS,
                    entryComponents: COMPONENTS,
                },] }
    ];
    return PickerModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-picker.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CityPickerComponent, DatePickerComponent, FORMAT, PickerComponent, PickerConfig, PickerGroupComponent, PickerModule, PickerService };
//# sourceMappingURL=ngx-weui-picker.js.map
