import { __assign } from 'tslib';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, ChangeDetectorRef, Input, Output, NgModule } from '@angular/core';
import { Observable, Subscription } from 'rxjs';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: popup.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PopupConfig = /** @class */ (function () {
    function PopupConfig() {
        /**
         * 是否全屏，默认：`false`
         */
        this.is_full = false;
        /**
         * 取消按钮文本，默认：`取消`
         */
        this.cancel = '取消';
        /**
         * 确定按钮文本，默认：`确定`
         */
        this.confirm = '确定';
        /**
         * 允许点击背景关闭，默认：`true`
         */
        this.backdrop = true;
    }
    PopupConfig.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ PopupConfig.ɵprov = ɵɵdefineInjectable({ factory: function PopupConfig_Factory() { return new PopupConfig(); }, token: PopupConfig, providedIn: "root" });
    return PopupConfig;
}());
if (false) {
    /**
     * 是否全屏，默认：`false`
     * @type {?}
     */
    PopupConfig.prototype.is_full;
    /**
     * 取消按钮文本，默认：`取消`
     * @type {?}
     */
    PopupConfig.prototype.cancel;
    /**
     * 确定按钮文本，默认：`确定`
     * @type {?}
     */
    PopupConfig.prototype.confirm;
    /**
     * 允许点击背景关闭，默认：`true`
     * @type {?}
     */
    PopupConfig.prototype.backdrop;
}

/**
 * @fileoverview added by tsickle
 * Generated from: popup.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PopupComponent = /** @class */ (function () {
    function PopupComponent(DEF, cdr) {
        this.DEF = DEF;
        this.cdr = cdr;
        this.shown = false;
        this._shownAnt = false;
        this.cancel = new EventEmitter();
        this.confirm = new EventEmitter();
        this.config = __assign({}, DEF);
    }
    Object.defineProperty(PopupComponent.prototype, "config", {
        get: /**
         * @return {?}
         */
        function () {
            return this._config;
        },
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this._config = __assign(__assign({}, this.DEF), val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PopupComponent.prototype, "_visibility", {
        get: /**
         * @return {?}
         */
        function () {
            return this._shownAnt ? 'show' : 'hide';
        },
        enumerable: true,
        configurable: true
    });
    /**
     * 显示，并支持订阅结果，如果点击取消值为false，反之 true
     */
    /**
     * 显示，并支持订阅结果，如果点击取消值为false，反之 true
     * @return {?}
     */
    PopupComponent.prototype.show = /**
     * 显示，并支持订阅结果，如果点击取消值为false，反之 true
     * @return {?}
     */
    function () {
        var _this = this;
        this.shown = true;
        setTimeout((/**
         * @return {?}
         */
        function () {
            _this._shownAnt = true;
            _this.cdr.detectChanges();
        }), 10);
        return new Observable((/**
         * @param {?} observer
         * @return {?}
         */
        function (observer) {
            _this.observer = observer;
        }));
    };
    /**
     * 隐藏
     *
     * @param [is_backdrop] 是否从背景上点击(可选)
     */
    /**
     * 隐藏
     *
     * @param {?=} is_backdrop
     * @return {?}
     */
    PopupComponent.prototype.hide = /**
     * 隐藏
     *
     * @param {?=} is_backdrop
     * @return {?}
     */
    function (is_backdrop) {
        var _this = this;
        if (is_backdrop === true && this.config.backdrop === false)
            return;
        this._shownAnt = false;
        this.cdr.detectChanges();
        setTimeout((/**
         * @return {?}
         */
        function () {
            _this.shown = false;
        }), 300);
    };
    /** 关闭，等同 `hide()` 效果 */
    /**
     * 关闭，等同 `hide()` 效果
     * @return {?}
     */
    PopupComponent.prototype.close = /**
     * 关闭，等同 `hide()` 效果
     * @return {?}
     */
    function () {
        this.hide(false);
    };
    /**
     * @return {?}
     */
    PopupComponent.prototype._onCancel = /**
     * @return {?}
     */
    function () {
        this.cancel.emit();
        this.hide(false);
        if (this.observer) {
            this.observer.next(false);
            this.observer.complete();
        }
        return false;
    };
    /**
     * @return {?}
     */
    PopupComponent.prototype._onConfirm = /**
     * @return {?}
     */
    function () {
        this.confirm.emit();
        this.hide(false);
        if (this.observer) {
            this.observer.next(true);
            this.observer.complete();
        }
        return false;
    };
    /**
     * @return {?}
     */
    PopupComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this.observer && this.observer instanceof Subscription) {
            this.observer.unsubscribe();
        }
    };
    PopupComponent.decorators = [
        { type: Component, args: [{
                    selector: 'weui-popup',
                    exportAs: 'weuiPopup',
                    template: "<div class=\"weui-mask\" [@visibility]=\"_visibility\" (click)=\"hide(true)\"></div>\n<div class=\"weui-popup\" [ngClass]=\"{ 'weui-popup_toggle': _shownAnt }\">\n  <div class=\"weui-popup__hd\" *ngIf=\"!config.is_full\">\n    <a href=\"#\" class=\"weui-popup__action\" (click)=\"_onCancel()\">{{ config.cancel }}</a>\n    <a href=\"#\" class=\"weui-popup__action\" (click)=\"_onConfirm()\">{{ config.confirm }}</a>\n  </div>\n  <div [ngClass]=\"{ 'weui-popup_full': config.is_full }\">\n    <ng-content></ng-content>\n  </div>\n</div>\n",
                    animations: [
                        trigger('visibility', [
                            state('show', style({ opacity: 1 })),
                            state('hide', style({ opacity: 0 })),
                            transition('hide <=> show', [animate(200)]),
                        ]),
                    ],
                    host: {
                        '[hidden]': '!shown',
                    },
                    preserveWhitespaces: false,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    PopupComponent.ctorParameters = function () { return [
        { type: PopupConfig },
        { type: ChangeDetectorRef }
    ]; };
    PopupComponent.propDecorators = {
        config: [{ type: Input }],
        cancel: [{ type: Output }],
        confirm: [{ type: Output }]
    };
    return PopupComponent;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    PopupComponent.prototype.observer;
    /** @type {?} */
    PopupComponent.prototype.shown;
    /** @type {?} */
    PopupComponent.prototype._shownAnt;
    /**
     * @type {?}
     * @private
     */
    PopupComponent.prototype._config;
    /** @type {?} */
    PopupComponent.prototype.cancel;
    /** @type {?} */
    PopupComponent.prototype.confirm;
    /**
     * @type {?}
     * @private
     */
    PopupComponent.prototype.DEF;
    /**
     * @type {?}
     * @private
     */
    PopupComponent.prototype.cdr;
}

/**
 * @fileoverview added by tsickle
 * Generated from: popup.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PopupModule = /** @class */ (function () {
    function PopupModule() {
    }
    PopupModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [PopupComponent],
                    exports: [PopupComponent],
                    entryComponents: [PopupComponent],
                },] }
    ];
    return PopupModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-popup.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { PopupComponent, PopupConfig, PopupModule };
//# sourceMappingURL=ngx-weui-popup.js.map
