import { Injectable, ɵɵdefineInjectable, Component, ChangeDetectionStrategy, ViewEncapsulation, ElementRef, NgZone, Input, NgModule } from '@angular/core';
import { __assign } from 'tslib';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: swiper.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SwiperConfig = /** @class */ (function () {
    function SwiperConfig() {
        /**
         * 等同于swiper[参数项](http://idangero.us/swiper/api/)
         */
        this.options = {
            loop: true,
            pagination: '.swiper-pagination',
        };
    }
    SwiperConfig.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ SwiperConfig.ɵprov = ɵɵdefineInjectable({ factory: function SwiperConfig_Factory() { return new SwiperConfig(); }, token: SwiperConfig, providedIn: "root" });
    return SwiperConfig;
}());
if (false) {
    /**
     * 等同于swiper[参数项](http://idangero.us/swiper/api/)
     * @type {?}
     */
    SwiperConfig.prototype.options;
}

/**
 * @fileoverview added by tsickle
 * Generated from: swiper.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SwiperComponent = /** @class */ (function () {
    function SwiperComponent(el, zone, DEF) {
        this.el = el;
        this.zone = zone;
        this.DEF = DEF;
    }
    /**
     * @private
     * @return {?}
     */
    SwiperComponent.prototype.initOptions = /**
     * @private
     * @return {?}
     */
    function () {
        this.options = __assign(__assign({}, this.DEF.options), this.options);
    };
    /**
     * @private
     * @return {?}
     */
    SwiperComponent.prototype.init = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this.destroy();
        this.zone.runOutsideAngular((/**
         * @return {?}
         */
        function () {
            _this.swiper = new Swiper(_this.containerEl, _this.options);
        }));
    };
    /**
     * @private
     * @return {?}
     */
    SwiperComponent.prototype.destroy = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.containerEl) {
            ['horizontal', 'vertical'].forEach((/**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                _this.containerEl.classList.remove('swiper-container-' + v);
            }));
        }
        if (this.swiper) {
            this.zone.runOutsideAngular((/**
             * @return {?}
             */
            function () {
                _this.swiper.destroy(true, false);
                _this.swiper = null;
            }));
        }
    };
    /**
     * @return {?}
     */
    SwiperComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.options)
            this.initOptions();
        this.containerEl = this.el.nativeElement.querySelector('.swiper-container');
        if (!this.containerEl)
            throw new Error('组件内容的HTML跟swiper所需要的DOM结构必须完全一样。');
    };
    /**
     * @return {?}
     */
    SwiperComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.init();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    SwiperComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (changes.options) {
            this.initOptions();
            if (!changes.options.firstChange) {
                this.init();
            }
        }
    };
    /**
     * @return {?}
     */
    SwiperComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroy();
    };
    SwiperComponent.decorators = [
        { type: Component, args: [{
                    selector: 'weui-swiper',
                    exportAs: 'weuiSwiper',
                    template: "\n    <ng-content></ng-content>\n  ",
                    preserveWhitespaces: false,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    SwiperComponent.ctorParameters = function () { return [
        { type: ElementRef },
        { type: NgZone },
        { type: SwiperConfig }
    ]; };
    SwiperComponent.propDecorators = {
        options: [{ type: Input }]
    };
    return SwiperComponent;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    SwiperComponent.prototype.containerEl;
    /**
     * 等同于swiper[参数项](http://idangero.us/swiper/api/)
     * @type {?}
     */
    SwiperComponent.prototype.options;
    /**
     * Swiper 实例对象，可以通过 `\@ViewChild` 访问到它
     * @type {?}
     */
    SwiperComponent.prototype.swiper;
    /**
     * @type {?}
     * @private
     */
    SwiperComponent.prototype.el;
    /**
     * @type {?}
     * @private
     */
    SwiperComponent.prototype.zone;
    /**
     * @type {?}
     * @private
     */
    SwiperComponent.prototype.DEF;
}

/**
 * @fileoverview added by tsickle
 * Generated from: swiper.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SwiperModule = /** @class */ (function () {
    function SwiperModule() {
    }
    SwiperModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [SwiperComponent],
                    exports: [SwiperComponent],
                },] }
    ];
    return SwiperModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-swiper.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { SwiperComponent, SwiperConfig, SwiperModule };
//# sourceMappingURL=ngx-weui-swiper.js.map
