import { __decorate, __metadata, __extends } from 'tslib';
import { DOCUMENT, CommonModule } from '@angular/common';
import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, Input, Output, ComponentFactoryResolver, ApplicationRef, Injector, Inject, ɵɵinject, INJECTOR, NgModule } from '@angular/core';
import { InputNumber, BaseService } from 'ngx-weui/core';

/**
 * @fileoverview added by tsickle
 * Generated from: toast.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ToastConfigType() { }
if (false) {
    /** @type {?} */
    ToastConfigType.prototype.text;
    /** @type {?} */
    ToastConfigType.prototype.icon;
    /** @type {?} */
    ToastConfigType.prototype.time;
}
var ToastConfig = /** @class */ (function () {
    function ToastConfig() {
        /**
         * 成功配置项
         */
        this.success = {
            text: '已完成',
            icon: 'weui-icon-success-no-circle',
            time: 2000,
        };
        /**
         * 加载中配置项
         */
        this.loading = {
            text: '加载中…',
            icon: 'weui-loading',
            time: 2000,
        };
    }
    ToastConfig.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ ToastConfig.ɵprov = ɵɵdefineInjectable({ factory: function ToastConfig_Factory() { return new ToastConfig(); }, token: ToastConfig, providedIn: "root" });
    return ToastConfig;
}());
if (false) {
    /**
     * 成功配置项
     * @type {?}
     */
    ToastConfig.prototype.success;
    /**
     * 加载中配置项
     * @type {?}
     */
    ToastConfig.prototype.loading;
}

/**
 * @fileoverview added by tsickle
 * Generated from: toast.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToastComponent = /** @class */ (function () {
    function ToastComponent(DEF) {
        this.DEF = DEF;
        /**
         * 显示时长后自动关闭（单位：ms），0 表示永久，默认：`2000`
         */
        this.time = 2000;
        /**
         * 隐藏后回调
         */
        this.hide = new EventEmitter();
        this._showd = false;
        this.type = 'success';
    }
    Object.defineProperty(ToastComponent.prototype, "type", {
        /**
         * 类型
         */
        set: /**
         * 类型
         * @param {?} _t
         * @return {?}
         */
        function (_t) {
            Object.assign(this, this.DEF[_t]);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    ToastComponent.prototype.onShow = /**
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    function () {
        var _this = this;
        (/** @type {?} */ (this))._showd = true;
        if ((/** @type {?} */ (this)).time > 0) {
            (/** @type {?} */ (this)).timer = setTimeout((/**
             * @return {?}
             */
            function () {
                (/** @type {?} */ (_this)).onHide();
            }), (/** @type {?} */ (this)).time);
        }
        return (/** @type {?} */ (this));
    };
    /**
     * @return {?}
     */
    ToastComponent.prototype.onHide = /**
     * @return {?}
     */
    function () {
        this._showd = false;
        this.hide.emit();
    };
    /**
     * @return {?}
     */
    ToastComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this.timer) {
            clearTimeout(this.timer);
            this.timer = null;
        }
    };
    ToastComponent.decorators = [
        { type: Component, args: [{
                    selector: 'weui-toast',
                    exportAs: 'weuiToast',
                    template: "<div class=\"weui-mask_transparent\"></div>\n<div class=\"weui-toast\">\n  <i class=\"{{ icon }} weui-icon_toast\"></i>\n  <p class=\"weui-toast__content\">{{ text }}</p>\n</div>\n",
                    host: {
                        '[hidden]': '!_showd',
                    },
                    preserveWhitespaces: false,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    ToastComponent.ctorParameters = function () { return [
        { type: ToastConfig }
    ]; };
    ToastComponent.propDecorators = {
        type: [{ type: Input }],
        text: [{ type: Input }],
        icon: [{ type: Input }],
        time: [{ type: Input }],
        hide: [{ type: Output }]
    };
    __decorate([
        InputNumber(),
        __metadata("design:type", Number)
    ], ToastComponent.prototype, "time", void 0);
    return ToastComponent;
}());
if (false) {
    /**
     * 文本
     * @type {?}
     */
    ToastComponent.prototype.text;
    /**
     * icon图标Class名
     * @type {?}
     */
    ToastComponent.prototype.icon;
    /**
     * 显示时长后自动关闭（单位：ms），0 表示永久，默认：`2000`
     * @type {?}
     */
    ToastComponent.prototype.time;
    /**
     * 隐藏后回调
     * @type {?}
     */
    ToastComponent.prototype.hide;
    /** @type {?} */
    ToastComponent.prototype._showd;
    /**
     * @type {?}
     * @private
     */
    ToastComponent.prototype.timer;
    /**
     * @type {?}
     * @private
     */
    ToastComponent.prototype.DEF;
}

/**
 * @fileoverview added by tsickle
 * Generated from: toast.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToastService = /** @class */ (function (_super) {
    __extends(ToastService, _super);
    function ToastService(resolver, applicationRef, injector, doc) {
        return _super.call(this, resolver, applicationRef, injector, doc) || this;
    }
    /**
     * 构建toast并显示
     *
     * @param [text] 文本（可选）
     * @param [time] 显示时长后自动关闭（单位：ms），0 表示永久（可选）
     * @param [icon] icon图标Class名（可选）
     * @param [type] 类型（可选）
     */
    /**
     * 构建toast并显示
     *
     * @param {?=} text
     * @param {?=} time
     * @param {?=} icon
     * @param {?=} type
     * @return {?}
     */
    ToastService.prototype.show = /**
     * 构建toast并显示
     *
     * @param {?=} text
     * @param {?=} time
     * @param {?=} icon
     * @param {?=} type
     * @return {?}
     */
    function (text, time, icon, type) {
        /** @type {?} */
        var componentRef = this.build(ToastComponent);
        if (type)
            componentRef.instance.type = type;
        if (text)
            componentRef.instance.text = text;
        if (icon)
            componentRef.instance.icon = icon;
        if (typeof time === 'number')
            componentRef.instance.time = time;
        componentRef.instance.hide.subscribe((/**
         * @return {?}
         */
        function () {
            setTimeout((/**
             * @return {?}
             */
            function () {
                componentRef.destroy();
            }), 300);
        }));
        return componentRef.instance.onShow();
    };
    /**
     * 关闭最新toast
     */
    /**
     * 关闭最新toast
     * @return {?}
     */
    ToastService.prototype.hide = /**
     * 关闭最新toast
     * @return {?}
     */
    function () {
        this.destroy();
    };
    /**
     * 构建成功toast并显示
     *
     * @param [text] 文本（可选）
     * @param [time] 显示时长后自动关闭（单位：ms）（可选）
     * @param [icon] icon图标Class名（可选）
     */
    /**
     * 构建成功toast并显示
     *
     * @param {?=} text
     * @param {?=} time
     * @param {?=} icon
     * @return {?}
     */
    ToastService.prototype.success = /**
     * 构建成功toast并显示
     *
     * @param {?=} text
     * @param {?=} time
     * @param {?=} icon
     * @return {?}
     */
    function (text, time, icon) {
        return this.show(text, time, icon, 'success');
    };
    /**
     * 构建加载中toast并显示
     *
     * @param [text] 文本（可选）
     * @param [time] 显示时长后自动关闭（单位：ms）（可选）
     * @param [icon] icon图标Class名（可选）
     */
    /**
     * 构建加载中toast并显示
     *
     * @param {?=} text
     * @param {?=} time
     * @param {?=} icon
     * @return {?}
     */
    ToastService.prototype.loading = /**
     * 构建加载中toast并显示
     *
     * @param {?=} text
     * @param {?=} time
     * @param {?=} icon
     * @return {?}
     */
    function (text, time, icon) {
        return this.show(text, time, icon, 'loading');
    };
    ToastService.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */
    ToastService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ApplicationRef },
        { type: Injector },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ ToastService.ɵprov = ɵɵdefineInjectable({ factory: function ToastService_Factory() { return new ToastService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR), ɵɵinject(DOCUMENT)); }, token: ToastService, providedIn: "root" });
    return ToastService;
}(BaseService));

/**
 * @fileoverview added by tsickle
 * Generated from: toast.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToastModule = /** @class */ (function () {
    function ToastModule() {
    }
    ToastModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [ToastComponent],
                    exports: [ToastComponent],
                    entryComponents: [ToastComponent],
                },] }
    ];
    return ToastModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-toast.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ToastComponent, ToastConfig, ToastModule, ToastService };
//# sourceMappingURL=ngx-weui-toast.js.map
