import { __decorate, __metadata, __extends } from 'tslib';
import { EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, ElementRef, Input, Output, Injectable, ComponentFactoryResolver, ApplicationRef, Injector, Inject, ɵɵdefineInjectable, ɵɵinject, INJECTOR, NgModule } from '@angular/core';
import { UpdateHostClassService, InputNumber, BaseService } from 'ngx-weui/core';
import { DOCUMENT, CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: toptips.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToptipsComponent = /** @class */ (function () {
    function ToptipsComponent(el, uhcs) {
        this.el = el;
        this.uhcs = uhcs;
        this._showd = false;
        /**
         * 显示时长后自动关闭（单位：ms），默认：`2000`
         */
        this.time = 2000;
        /**
         * 类型
         */
        this.type = 'primary';
        /**
         * 隐藏后回调
         */
        this.hide = new EventEmitter();
    }
    /**
     * @private
     * @return {?}
     */
    ToptipsComponent.prototype.setClassMap = /**
     * @private
     * @return {?}
     */
    function () {
        var _a;
        /** @type {?} */
        var prefixCls = 'weui-toptips';
        var _b = this, uhcs = _b.uhcs, el = _b.el, type = _b.type;
        uhcs.updateHostClass(el.nativeElement, (_a = {},
            _a["" + prefixCls] = true,
            _a[prefixCls + "__" + type] = true,
            _a));
    };
    /**
     * @return {?}
     */
    ToptipsComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.setClassMap();
    };
    /**
     * @return {?}
     */
    ToptipsComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        this.setClassMap();
    };
    /**
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    ToptipsComponent.prototype.onShow = /**
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    function () {
        var _this = this;
        (/** @type {?} */ (this)).destroy();
        (/** @type {?} */ (this))._showd = true;
        (/** @type {?} */ (this)).timer = setTimeout((/**
         * @return {?}
         */
        function () { return (/** @type {?} */ (_this)).onHide(); }), (/** @type {?} */ (this)).time);
        return (/** @type {?} */ (this));
    };
    /**
     * @return {?}
     */
    ToptipsComponent.prototype.onHide = /**
     * @return {?}
     */
    function () {
        this._showd = false;
        this.hide.emit();
    };
    /**
     * @private
     * @return {?}
     */
    ToptipsComponent.prototype.destroy = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.timer) {
            clearTimeout(this.timer);
            this.timer = null;
        }
    };
    /**
     * @return {?}
     */
    ToptipsComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroy();
    };
    ToptipsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'weui-toptips',
                    exportAs: 'weuiToptips',
                    template: "\n    {{ text }}<ng-content></ng-content>\n  ",
                    host: {
                        '[hidden]': '!_showd',
                        '[style.display]': '_showd ? "block" : "none"',
                    },
                    providers: [UpdateHostClassService],
                    preserveWhitespaces: false,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    ToptipsComponent.ctorParameters = function () { return [
        { type: ElementRef },
        { type: UpdateHostClassService }
    ]; };
    ToptipsComponent.propDecorators = {
        text: [{ type: Input }],
        time: [{ type: Input }],
        type: [{ type: Input }],
        hide: [{ type: Output }]
    };
    __decorate([
        InputNumber(),
        __metadata("design:type", Number)
    ], ToptipsComponent.prototype, "time", void 0);
    return ToptipsComponent;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ToptipsComponent.prototype.timer;
    /** @type {?} */
    ToptipsComponent.prototype._showd;
    /**
     * 文本
     * @type {?}
     */
    ToptipsComponent.prototype.text;
    /**
     * 显示时长后自动关闭（单位：ms），默认：`2000`
     * @type {?}
     */
    ToptipsComponent.prototype.time;
    /**
     * 类型
     * @type {?}
     */
    ToptipsComponent.prototype.type;
    /**
     * 隐藏后回调
     * @type {?}
     */
    ToptipsComponent.prototype.hide;
    /**
     * @type {?}
     * @private
     */
    ToptipsComponent.prototype.el;
    /**
     * @type {?}
     * @private
     */
    ToptipsComponent.prototype.uhcs;
}

/**
 * @fileoverview added by tsickle
 * Generated from: toptips.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToptipsService = /** @class */ (function (_super) {
    __extends(ToptipsService, _super);
    function ToptipsService(resolver, applicationRef, injector, doc) {
        return _super.call(this, resolver, applicationRef, injector, doc) || this;
    }
    /**
     * 构建一个Toptips并显示
     *
     * @param text 文本
     * @param type 类型
     * @param 显示时长后自动关闭（单位：ms）
     */
    /**
     * 构建一个Toptips并显示
     *
     * @param {?} text 文本
     * @param {?} type 类型
     * @param {?=} time
     * @return {?}
     */
    ToptipsService.prototype.show = /**
     * 构建一个Toptips并显示
     *
     * @param {?} text 文本
     * @param {?} type 类型
     * @param {?=} time
     * @return {?}
     */
    function (text, type, time) {
        var _this = this;
        if (time === void 0) { time = 2000; }
        /** @type {?} */
        var componentRef = this.build(ToptipsComponent);
        if (type)
            componentRef.instance.type = type;
        if (text)
            componentRef.instance.text = text;
        componentRef.instance.time = time;
        componentRef.instance.hide.subscribe((/**
         * @return {?}
         */
        function () {
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this.destroy(componentRef);
            }), 100);
        }));
        return componentRef.instance.onShow();
    };
    /**
     * 构建一个Warn Toptips并显示
     *
     * @param text 文本
     * @param time 显示时长后自动关闭（单位：ms）
     */
    /**
     * 构建一个Warn Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    ToptipsService.prototype.warn = /**
     * 构建一个Warn Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    function (text, time) {
        if (time === void 0) { time = 2000; }
        return this.show(text, 'warn', time);
    };
    /**
     * 构建一个Info Toptips并显示
     *
     * @param text 文本
     * @param time 显示时长后自动关闭（单位：ms）
     */
    /**
     * 构建一个Info Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    ToptipsService.prototype.info = /**
     * 构建一个Info Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    function (text, time) {
        if (time === void 0) { time = 2000; }
        return this.show(text, 'info', time);
    };
    /**
     * 构建一个Primary Toptips并显示
     *
     * @param text 文本
     * @param time 显示时长后自动关闭（单位：ms）
     */
    /**
     * 构建一个Primary Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    ToptipsService.prototype.primary = /**
     * 构建一个Primary Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    function (text, time) {
        if (time === void 0) { time = 2000; }
        return this.show(text, 'primary', time);
    };
    /**
     * 构建一个Success Toptips并显示
     *
     * @param text 文本
     * @param time 显示时长后自动关闭（单位：ms）
     */
    /**
     * 构建一个Success Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    ToptipsService.prototype.success = /**
     * 构建一个Success Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    function (text, time) {
        if (time === void 0) { time = 2000; }
        return this.show(text, 'primary', time);
    };
    /**
     * 构建一个Default Toptips并显示
     *
     * @param text 文本
     * @param time 显示时长后自动关闭（单位：ms）
     */
    /**
     * 构建一个Default Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    ToptipsService.prototype.default = /**
     * 构建一个Default Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    function (text, time) {
        if (time === void 0) { time = 2000; }
        return this.show(text, 'default', time);
    };
    ToptipsService.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */
    ToptipsService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ApplicationRef },
        { type: Injector },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ ToptipsService.ɵprov = ɵɵdefineInjectable({ factory: function ToptipsService_Factory() { return new ToptipsService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR), ɵɵinject(DOCUMENT)); }, token: ToptipsService, providedIn: "root" });
    return ToptipsService;
}(BaseService));

/**
 * @fileoverview added by tsickle
 * Generated from: toptips.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToptipsModule = /** @class */ (function () {
    function ToptipsModule() {
    }
    ToptipsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [ToptipsComponent],
                    exports: [ToptipsComponent],
                    entryComponents: [ToptipsComponent],
                },] }
    ];
    return ToptipsModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-toptips.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ToptipsComponent, ToptipsModule, ToptipsService };
//# sourceMappingURL=ngx-weui-toptips.js.map
