import { EventEmitter, OnDestroy } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { PickerOptions } from './options';
import { PickerComponent } from './picker.component';
/**
 * 城市选择器（并不包含城市数据，可以参考示例中的数据格式）
 */
export declare class CityPickerComponent implements ControlValueAccessor, OnDestroy {
    private _tmpData;
    private onChange;
    private onTouched;
    _value: string;
    _groups: any[] | null;
    _selected: number[];
    /** 城市数据，可以参考示例中的数据格式 */
    set data(d: any);
    _pickerInstance: PickerComponent;
    dataMap: {
        label: string;
        value: string;
        items: string;
    };
    /** 配置项 */
    options: PickerOptions;
    /** 当options.type=='form'时，占位符文本 */
    placeholder: string;
    title: string;
    disabled: boolean;
    /**
     * 确认后回调当前选择数据（包括已选面板所有数据）
     *
     * `{ value: '10000', items: [ {}, {}, {} ] }`
     */
    readonly change: EventEmitter<any>;
    /** 列变更时回调 */
    readonly groupChange: EventEmitter<any>;
    /** 取消后回调 */
    readonly cancel: EventEmitter<any>;
    /** 显示时回调 */
    readonly show: EventEmitter<any>;
    /** 隐藏后回调 */
    readonly hide: EventEmitter<any>;
    ngOnDestroy(): void;
    private parseData;
    /**
     * 将值转换成位置
     */
    private valueToSelect;
    _onCityChange(data: any): void;
    _onCityGroupChange(res: any): void;
    _onCityCancelChange(): void;
    /** 服务于Service，并无实际意义 */
    _triggerShow(): void;
    _onShow(): void;
    _onHide(): void;
    writeValue(value: any): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
}
